'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

exports['default'] = function (scaffolds) {
  var command = 'build';

  var options = {
    scaffold: {
      position: 1,
      help: 'Scaffold name',
      type: 'string',
      required: true,
      // Allow to enter only one of existing scaffolds
      choices: Object.keys(scaffolds)
    }
  };

  var callback = function callback(_ref) {
    var scaffold = _ref.scaffold;

    var opts = _objectWithoutProperties(_ref, ['scaffold']);

    var packageJson = require(_path2['default'].join(scaffolds[scaffold], 'package.json'));
    var cli = require(_path2['default'].join(scaffolds[scaffold], packageJson.main));

    return cli(opts);
  };

  var help = 'Build a new package from a Cloverfield scaffold';

  return { command: command, options: options, callback: callback, help: help };
};

module.exports = exports['default'];